src/project/urls.py
"""URLs for the membersystem."""

from django.conf import settings
from django.contrib import admin
from django.urls import include
from django.urls import path
from django_view_decorator import include_view_urls

urlpatterns = [
    path("", include_view_urls(extra_modules=["project.views"])),
    path("o/", include("oauth2_provider.urls", namespace="oauth2_provider")),
    path("accounts/", include("allauth.urls")),
    path("_admin/", admin.site.urls),
]

if settings.DEBUG:
    urlpatterns = [
        path("__debug__/", include("debug_toolbar.urls")),
        path("__reload__/", include("django_browser_reload.urls")),
        *urlpatterns,
    ]

src/accounting/views.py
"""Views for the membership app."""

import stripe
from django.conf import settings
from django.contrib.sites.models import Site
from django.core.mail import mail_admins
from django.db import transaction
from django.http import HttpRequest
from django.http import HttpResponse
from django.shortcuts import get_object_or_404
from django.shortcuts import redirect
from django.shortcuts import render
from django.urls import reverse
from django.views.decorators.csrf import csrf_exempt
from django_view_decorator import namespaced_decorator_factory
from djmoney.money import Money

from . import models

order_view = namespaced_decorator_factory(namespace="order", base_path="order")

stripe.api_key = settings.STRIPE_API_KEY


@order_view(
    paths="<int:order_id>/",
    name="detail",
    login_required=True,
)
def order_detail(request: HttpRequest, order_id: int) -> HttpResponse:
    """View to show the details of a member."""
    user = request.user  # People just need to login to pay something, not necessarily be a member
    order = models.Order.objects.get(pk=order_id, member=user)

    context = {
        "order": order,
    }

    return render(
        request=request,
        template_name="accounting/order/detail.html",
        context=context,
    )


@order_view(
    paths="<int:order_id>/pay/",
    name="pay",
    login_required=True,
)
def order_pay(request: HttpRequest, order_id: int) -> HttpResponse:
    """Create a Stripe session and redirects to Stripe Checkout."""
    user = request.user  # People just need to login to pay something, not necessarily be a member
    order = models.Order.objects.get(pk=order_id, member=user)
    current_site = Site.objects.get_current(request)
    base_domain = f"https://{current_site.domain}"
    if settings.DEBUG:
        f"http://{current_site.domain}"

    try:
        line_items = []
        for item in order.items.all():
            line_items.append(  # noqa: PERF401
                {
                    "price_data": {
                        "currency": item.total_with_vat.currency,
                        "unit_amount": int((item.price + item.vat).amount * 100),
                        "product_data": {
                            "name": item.product.name,
                        },
                    },
                    "quantity": item.quantity,
                }
            )
        checkout_session = stripe.checkout.Session.create(
            line_items=line_items,
            metadata={"order_id": order.id},
            mode="payment",
            success_url=base_domain + reverse("order:success", kwargs={"order_id": order.id}),
            cancel_url=base_domain + "/cancel",
        )
    except Exception as e:
        mail_admins("Error in checkout", str(e))
        raise

    # TODO(benjaoming): Redirect with status=303
    #  https://git.data.coop/data.coop/membersystem/issues/63
    # TODO(reynir): url is None if session is not active
    return redirect(checkout_session.url)


@transaction.atomic
@order_view(
    paths="<int:order_id>/pay/success/",
    name="success",
    login_required=True,
)
def success(request: HttpRequest, order_id: int) -> HttpResponse:
    """Create a Stripe session and redirects to Stripe Checkout.

    From Stripe docs: When you have a webhook endpoint set up to listen for checkout.session.completed events and
    you set a success_url, Checkout waits for your server to respond to the webhook event delivery before redirecting
    your customer. If you use this approach, make sure your server responds to checkout.session.completed events as
    quickly as possible.
    """
    user = request.user  # People just need to login to pay something, not necessarily be a member
    order = get_object_or_404(models.Order, pk=order_id, member=user)

    context = {
        "order": order,
    }

    return render(
        request=request,
        template_name="accounting/order/success.html",
        context=context,
    )


@transaction.atomic
@order_view(
    paths="<int:order_id>/pay/cancel/",
    name="cancel",
    login_required=True,
)
def cancel(request: HttpRequest, order_id: int) -> HttpResponse:
    """Page to display when a payment is canceled."""
    user = request.user  # People just need to login to pay something, not necessarily be a member
    order = models.Order.objects.get(pk=order_id, member=user)

    context = {
        "order": order,
    }

    return render(
        request=request,
        template_name="accounting/order/cancel.html",
        context=context,
    )


@transaction.atomic
@order_view(
    paths="stripe/webhook/",
    name="webhook",
)
@csrf_exempt
def stripe_webhook(request: HttpRequest) -> HttpResponse:
    """Handle Stripe webhook.

    https://docs.stripe.com/metadata/use-cases
    """
    payload = request.body
    sig_header = request.headers["stripe-signature"]
    event = None

    try:
        event = stripe.Webhook.construct_event(payload, sig_header, settings.STRIPE_ENDPOINT_SECRET)
    except ValueError:
        # Invalid payload
        return HttpResponse(status=400)
    except stripe.error.SignatureVerificationError:
        # Invalid signature
        return HttpResponse(status=400)

    if event["type"] == "checkout.session.completed" or event["type"] == "checkout.session.async_payment_succeeded":
        # Order is marked paid via signals, Membership is activated via signals.
        order_id = event["data"]["object"]["metadata"]["order_id"]
        order = get_object_or_404(models.Order, pk=order_id)
        if not models.Payment.objects.filter(order=order).exists():
            models.Payment.objects.create(
                order=order,
                amount=Money(event["data"]["object"]["amount_total"] / 100.0, event["data"]["object"]["currency"]),
                description="Paid via Stripe",
                payment_type=models.PaymentType.objects.get_or_create(name="Stripe")[0],
                external_transaction_id=event["id"],
            )

    return HttpResponse(status=200)

src/project/views.py
"""Project views."""

from __future__ import annotations

from typing import TYPE_CHECKING

from accounting.models import Order
from django_view_decorator import view
from utils.view_utils import render

if TYPE_CHECKING:
    from django.http import HttpRequest
    from django.http import HttpResponse


@view(
    paths="",
    name="index",
    login_required=True,
)
def index(request: HttpRequest) -> HttpResponse:
    """View to show the index page."""
    unpaid_orders = Order.objects.filter(member=request.user, is_paid=False)

    context = {"unpaid_orders": list(unpaid_orders)}

    return render(request, "index.html", context=context)

src/project/templates/base.html
{% load utils %}
{% load i18n %}
{% load static %}
<!doctype html>
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <meta name="description" content="">
        <title>{% block head_title %}{% endblock %} – {{ site.name }}</title>
        <link rel="stylesheet" href="{% static "fonts/inter.css" %}">
        <link rel="stylesheet" href="{% static "css/style.css" %}">
        <link rel="stylesheet" href="{% static "css/dark-style.css" %}">
        <script>
          const savedTheme = localStorage.getItem('theme');

          if (savedTheme === "dark" || (savedTheme == null && window.matchMedia("(prefers-color-scheme: dark)").matches)) {
            document.querySelector('html').classList.add('dark');
          }
        </script>
    </head>
    <body>
        <header>
            <h1> data.coop membersystem </h1>
            <div>
              <a id="theme-switcher" title="Switch theme">
                <svg id="switch-icon"
                   width="20.00033mm"
                   height="20.000334mm"
                   viewBox="0 0 20.00033 20.000334"
                   version="1.1"
                   id="svg1"
                   xmlns="http://www.w3.org/2000/svg"
                   xmlns:svg="http://www.w3.org/2000/svg">
                  <defs
                     id="defs1" />
                  <g id="layer1">
                    <path id="path1"
                       style="fill-opacity:1;stroke:none;stroke-width:0.697782;stroke-linecap:round"
                       d="M 9.999906,20.000334 A 10,10 0 0 0 20.000329,9.999911 10,10 0 0 0 9.999906,0 10,10 0 0 0 0,9.999911 10,10 0 0 0 9.999906,20.000334 Z m 0,-2.00039 V 1.99988 a 8,8 0 0 1 8.000023,8.000031 8,8 0 0 1 -8.000023,8.000033 z" />
                  </g>
                </svg>
              </a>
              <a id="logout" href="{% url "account_logout" %}">Log out</a>
            </div>
        </header>
        <main>
            <aside>
                <div>
                    <figure></figure>
                    <h2>{{ user }}</h2>

                    {% if current_membership %}
                    <dl>
                        <dt>Membership</dt>
                        <dd>
                            Active
                        </dd>

                        <dt>Period</dt>
                        <dd>
                            Until {{ current_period.upper }} <span class="time_remaining">({{ current_period.upper|timeuntil }})</span>
                        </dd>

                        <dt>Membership type</dt>
                        <dd>Normal member</dd>
                    </dl>
                    {% else %}
                        Your membership status will be displayed here in the future.
                    {% endif %}
                </div>
            </aside>
            <nav>
                <ol>
                    <li>
                        <a href="/" class="{% active_path "index" "current" %}">
                            Dashboard
                        </a>
                    </li>

                    {% if user.is_superuser %}
                    <li>
                        <a href="{% url "services:list" %}" class="{% active_path "services:list" "current" %}">
                            Services
                        </a>
                    </li>
                    {% endif %}

                    <li>
                        <a href="{% url "account_email" %}" class="{% active_path "account_email" "current" %}">
                            Email
                        </a>
                    </li>

                    {% if perms.membership.administrate_memberships %}
                    <li>
                        <a href="{% url "admin-members:list" %}" class="{% active_path "admin-members:list" "current" %}">
                            Admin
                        </a>
                    </li>
                    {% endif %}
                </ol>
            </nav>
            <article>
                {% if messages %}
                  <div class="content-view">
                  {% for message in messages %}
                    <p>📨</p>
                    <p><strong>{{ message }}</strong></p>
                  {% endfor %}
                  </div>

                {% endif %}

                {% block content %}{% endblock %}
            </article>
        </main>
        <footer>
            data.coop membersystem alpha - report issues on <a href="https://git.data.coop/data.coop/membersystem/">git</a>
        </footer>
        <script>
          const themeSwitcher = document.getElementById('theme-switcher');
          themeSwitcher.addEventListener('click', function() {
            themeSwitcher.classList.toggle('active')
            let isDark = document.querySelector('html').classList.toggle('dark');

            localStorage.setItem('theme', isDark ? 'dark' : 'light');
          });
        </script>
    </body>
</html>

src/project/templates/index.html
{% extends "base.html" %}

{% block head_title %}
    {% trans "Home" %}
{% endblock %}

{% block content %}
    <div class="content-view">
        <h2>Welcome {{ user }}!</h2>
        <p>
            This is the new member area.
        </p>
        <p>
            It is very much under construction.
        </p>

        {% for order in unpaid_orders %}
          <p>You have an unpaid order: <a href="{% url "order:detail" order_id=order.id %}">View Order ID {{ order.id }}</a></p>
        {% endfor %}

        {% comment %}
        <hr>
        <br>
        <div class="infobox">
            <p>
                To get started we need you to verify your email!
            </p>
            <button>Verify email</button>
        </div>
        {% endcomment %}
    </div>
{% endblock %}